
Ruby - Bug #701

Wrong behaviour of StringIO#ungetc

10/30/2008 11:18 PM - eao197 (Yauheni Akhotnikau)

Status: Closed   

Priority: Normal   

Assignee:    

Target version: 1.9.1 Release Candidate   

ruby -v:  Backport:  

Description

=begin

This is the behaviour of StringIO#ungetc from Ruby 1.8.7:

irb(main):001:0> require 'stringio'

=> true

irb(main):002:0> a=StringIO.new('abcd')

=> #StringIO:0x2ba7e24

irb(main):003:0> a.getc;a.getc;a.getc;a.tell # Read 'a','b','c'. Current position is on 'd'.

=> 3

irb(main):004:0> a.ungetc(?#)

=> nil

irb(main):005:0> a.tell

=> 2

irb(main):006:0> a.string

=> "ab#d"

irb(main):007:0>

And this is from Ruby 1.9.1 (Win32 version):

irb(main):001:0> require 'stringio'

=> true

irb(main):002:0> a=StringIO.new('abcd')

=> #StringIO:0xe0388c

irb(main):003:0> a.getc; a.getc; a.getc; a.tell

=> 3

irb(main):004:0> a.ungetc('#')

=> nil

irb(main):005:0> a.tell

=> 1

irb(main):006:0> a.string

=> "a#cd"

a.ungetc should replace 'c' to '#', but not 'b'.

=end

Associated revisions

Revision ecdd96c58d715baa34290d140fc2b58e95f335b3 - 11/08/2008 08:48 AM - matz (Yukihiro Matsumoto)

ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8@20151 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ecdd96c58d715baa34290d140fc2b58e95f335b3 - 11/08/2008 08:48 AM - matz (Yukihiro Matsumoto)

ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8@20151 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ecdd96c5 - 11/08/2008 08:48 AM - matz (Yukihiro Matsumoto)
ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8@20151 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 783b5e40d8d040b3bce4f61a15267418571e063c - 02/09/2009 04:39 AM - shyouhei (Shyouhei Urabe)

merge revision(s) 20151:

* ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8_6@22161 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 783b5e40d8d040b3bce4f61a15267418571e063c - 02/09/2009 04:39 AM - shyouhei (Shyouhei Urabe)

merge revision(s) 20151:

* ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8_6@22161 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 783b5e40 - 02/09/2009 04:39 AM - shyouhei (Shyouhei Urabe)

merge revision(s) 20151:

* ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8_6@22161 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d8646119b7e2f616e6c36cb50d56b027091db8d4 - 02/09/2009 04:40 AM - shyouhei (Shyouhei Urabe)

merge revision(s) 20151:

* ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8_7@22163 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d8646119b7e2f616e6c36cb50d56b027091db8d4 - 02/09/2009 04:40 AM - shyouhei (Shyouhei Urabe)

merge revision(s) 20151:

* ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8_7@22163 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d8646119 - 02/09/2009 04:40 AM - shyouhei (Shyouhei Urabe)

merge revision(s) 20151:

* ext/stringio/stringio.c (strio_ungetc): should allow ungetc at

the top of the buffer.  ref #701

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_8_7@22163 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/08/2008 05:37 PM - matz (Yukihiro Matsumoto)

- Status changed from Open to Closed

- % Done changed from 0 to 100

=begin

Applied in changeset r20150.

=end
